#version 330 core

/*
jml live voting committee in GLSL:
semifast music compo (name)votes:
1. apinan papana by roz/fit
2. ylvays/jml
=> WINNER
3. dekathlon by juzdie/artline designs
=> WINNER (even though it has wrong group)
4. dkd imee vy player one/dkd
5. the music song by p-kl/jml
=> WINNER

basic demo
1. yleisradio
2. spiikin demo
3. z-basic by zerox
4. happy birthday dekadence by terwiz

halt and catch fire
*/

in vec2 texCoord;
in vec2 texCoordStill;
in vec4 vertexFragColor;
out vec4 fragColor;
uniform sampler2D texture0;
uniform sampler2D texture1;
uniform vec4 colorRoad = vec4(0.3,0.3,0.3,1);
uniform vec4 colorTerrain = vec4(0.3,0.45,0.3,1);
uniform vec4 colorGrid = vec4(1,0,0,1);
uniform bool enableVertexColor = true;
in float xSpaceFrag;

float gridColor(vec2 tex, float size) {
    vec2 Coord = tex;
    Coord = cos(3.141592/size*Coord);
    return smoothstep(0.98,1.0,max(Coord.x,Coord.y));
}

void main() {
    fragColor = colorRoad;
    vec2 tex = texCoord;

    fragColor = (colorTerrain*0.2) + texture(texture0, texCoord)*0.8;

    vec4 runwayColor = texture(texture1, texCoord.yx);
    if (runwayColor.a > 0) {
        fragColor = runwayColor;
    }

    float grid = gridColor(texCoordStill, 0.01);
    if (grid > 0.0) {
        fragColor *= grid*0.8;
    }

    fragColor.a = 1;

    /*// road
    if (tex.x-0.5 > xSpaceFrag-0.009 && tex.x-0.5 < xSpaceFrag-0.004) {
        fragColor = colorGrid;
    } else if (tex.x-0.5+xSpaceFrag > 0 && tex.x-0.5+xSpaceFrag-0.004 < 0) {
        fragColor = colorGrid;
    } else if (abs(tex.x - 0.5) < xSpaceFrag*0.08 && mod(tex.y*0.7, 0.1) < 0.04) {
        fragColor = colorGrid;
    }*/
}
